
// warning - some of this was very obscure and not in the normal dox




// A/D documentation
  // ads.setGain(GAIN_TWOTHIRDS);  // 2/3x gain +/- 6.144V  1 bit =  0.1875mV (default)
  // ads.setGain(GAIN_ONE);        // 1x gain   +/- 4.096V  1 bit =  0.125mV
  // ads.setGain(GAIN_TWO);        // 2x gain   +/- 2.048V  1 bit =  0.0625mV
  // ads.setGain(GAIN_FOUR);       // 4x gain   +/- 1.024V  1 bit =  0.03125mV
  // ads.setGain(GAIN_EIGHT);      // 8x gain   +/- 0.512V  1 bit =  0.015625mV
  // ads.setGain(GAIN_SIXTEEN);    // 16x gain  +/- 0.256V  1 bit =  0.0078125mV
#pragma once

#ifdef __cplusplus
extern "C" {
#endif

char *dtostrf(double val, signed char width, unsigned char prec, char *sout);

#ifdef __cplusplus
}
#endif

#include <ESP8266WiFi.h>
#include <WiFiUdp.h>

#include <Wire.h>
#include <Doug_ADS1015.h> // changed to add continuous mode etc
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include <Adafruit_SHT31.h>

#define OLED_RESET 16
#define D_ADDR 0x3C

// sensors/display
Doug_ADS1115 adV(ADS1015_ADDRESS);  /* Use this for the 16-bit version */
Doug_ADS1115 adA(ADS1015_ADDRESS+1);  /* Use this for the 16-bit version */

Adafruit_SSD1306 display(OLED_RESET);
Adafruit_SHT31 sht31 = Adafruit_SHT31();


//@@@ below are hardcoded!
#define WAP "dougswap"
#define WPASS "fusordoug"
#define DNSPORT 53831
#define DATAPORT 42042
IPAddress ip(192,168,1,24); // Node static IP!
IPAddress gateway(192,168,1,1);
IPAddress subnet(255,255,255,0);
////////// end of network-specific stuff

//LED_PIN lights when low
// nope, it's d16 #define LED_PIN 0
// SPI wiring pinouts
//#define MAXCLK  13
//#define MAXCS   12
//#define MAXDO   14

// I2C wiring: 4 is SDA, 5 is SCL


WiFiUDP tport;  // port for tellem stuff - LANDNS
WiFiUDP dport;  // for regular comm
// stuff for LANDNS
char packetBuffer[255]; // to handle anything coming in that port
IPAddress myip; // my ip as assigned by dhcp
IPAddress bcip; // broadcast addr for this network
char sendstring[80]; // tellem send string
// "opsys crap"
unsigned long milliz;
unsigned long minm; // milliseconds inside minute, melts in your mouth
unsigned long millizs; //for seconds scheduler
unsigned long mins;  // millis within this second
int CmdSize; // is there host command waiting?
bool did_something;  // helps us do just one thing per roundy round
bool do_update;
bool do_ditch;
bool do_update_display;
bool handle_host; 
// data crap
int16_t AD0result; // raw a/d
int16_t AD1result;
float vfactor; // TODO fix this for real divider before installation
float afactor; // fix this too for real life
float BVi; // instantaneous bat volts
float BAi; // instantaneous amps
float batvolts; // filtered and scaled
float batamps; // filtered and scaled
float t;
float h;
unsigned ucount; // divisor for average when report generated 
float factor; // will be computed as 1/ucount as needed
char ReportString[255]; // probably has some extra space

// debug stuff
bool debug;
bool asetup;
////////////////////////////////////////////
void init_ram()
{ // keep this all in one place
  // I know not all of thise needs done here, but...
 milliz = minm = millizs = mins = 0; // unsigned longs
 vfactor = .00097136; // floats
 afactor = .0158433; //.015625;  // mv per count (A_D gain - divider Rs)
// TcC = IntC = 0; // nearly-raw readings
 batvolts = batamps = 0; // data results
 ucount = 0; // hope we don't get called while this is still zero
 did_something = do_ditch = do_update = handle_host= do_update_display = false;
 asetup = true; // print raw amp a/d values so knob is easy to set
 debug = true; // bools

}
////////////////////////////////////////////
void build_host_info()
{ // name is built someplace I can't find to change (issue on web, no one can)
 unsigned char mac[6]; // my mac, I hope
 String mymsg; // name, space, myip for tellem
 WiFi.macAddress(mac); // get our mac address to build our hostname with   
 myip = WiFi.localIP(); // class and union of dword and 4 bytes
 bcip = myip; // copy net address but
 bcip[3] = 255; // make it broadcast address
 mymsg = myip.toString();
 mymsg += " ESP_";
 for (int i=3;i<6;i++) // we just want last 3 of mac
 {
   mymsg += String(mac[i],HEX);
 }
 //mymsg += CAPS;  // capabilities for this unit
 mymsg += "_BAT";
 mymsg.toUpperCase();
 mymsg.toCharArray(sendstring,80);
}
////////////////////////////////////////////
void tellem()
{ // broadcast our name and IP on the tellme port
  tport.beginPacket(bcip,DNSPORT);
  tport.write(sendstring);
  tport.endPacket(); 
}
////////////////////////////////////////////
void ditch_incoming()
{ // we don't need to know anyone else's name/ip
  int packetSize = tport.parsePacket();
  if (packetSize) {
    int len = tport.read(packetBuffer, 254);
    if (debug)
    {
    if (len > 0) packetBuffer[len] = 0;
    Serial.println(packetBuffer);
    }  
  }
  did_something = true;
  do_ditch = false;
}
////////////////////////////////////////////
// These updaters make some data we can read anytime, presumed accurate
// whenever we want to read them
////////////////////////////////////////////
void update_readings()
{ // call once per interval, builds sums and a count for later mean
  // read the a/d, do unit conversion, sum for later divide

/*
  // battery voltage:
 AD0result = ads.readADC_Differential_0_1();
 BVi = AD0result * vfactor;  // for display "this reading"
 batvolts += BVi; // sum for later averaging

 AD1result = ads.readADC_Differential_2_3();
 BAi = AD1result * afactor;
 batamps += BAi;
 */
 // instead, get the last one since it's now continous
 AD0result = adV.getLastConversion();
 BVi = AD0result * vfactor;  // for display "this reading"
 batvolts += BVi; // sum for later averaging

 AD1result = adA.getLastConversion();
 BAi = AD1result * afactor;
 batamps += BAi;
 
 t = sht31.readTemperature();
 h = sht31.readHumidity();
 t *= 1.8;
 t+=32;

 if (asetup)
 { // make it easy to set balance/gain if in setup mode 
  Serial.print("////////////////////// voltage: ");
  Serial.println(BVi);
  Serial.print("///////////////////////// amps: ");
  Serial.println (BAi);
 }
 
 ucount++; // update divisor for mean calc later
 did_something = true; // we spent some cycles
 do_update = false; // we did this
}

////////////////////////////////////////////
void update_display()
{
  display.clearDisplay();
  display.setTextSize(2);
  display.setTextColor(WHITE);
  display.setCursor(0,0);
  
  display.print(BVi,2);
  display.println("v");

//  display.println();

  display.print(BAi,1);
  display.println("a");
//  display.println();
  
  display.print("Temp:");
  display.print(t,1);
  display.println(); // more won't fit on line at text size 2
  
  display.print("RH:");
  display.print(h,1);
  display.println(); // may not need
  
  display.display();
  did_something = true; // we spent some cycles
  do_update_display = false; // we did this
}

////////////////////////////////////////////
void ReportData()
{
  factor = 1.0/ucount; // do one divide to save cycles
  batvolts *= factor;  // use results of divide in faster multiply
  batamps *= factor;   // big cycle savings for normalizing average

  // needed weird include above to support floats
  sprintf(ReportString,"BATV:\t%.3f\tBATA:\t%.3f\tTemp:\t%.1f\tH:\t%.1f\n",batvolts,batamps,t,h);
  if (debug)
  {
    Serial.println();
    Serial.print(ReportString); 
  }

 // leave mean values intact in case we get called right away again somehow
  ucount = 1; // so this is true and we never risk divide by zero

  dport.beginPacket(dport.remoteIP(), dport.remotePort());
  dport.write(ReportString);
  dport.endPacket(); // out with you 
}

////////////////////////////////////////////
void HandleHost()
{// look for incoming on dataport and do whatever about it
  // ! means reset - or will when the ESP function works
  // r means report sensors (reset flow too)

 int len = dport.read(packetBuffer, 254); // re-using packetBuffer here
 if (len > 0) packetBuffer[len] = 0; // just in case, zero-terminate

 switch(packetBuffer[0])
 {
  case '!':
  ESP.reset();
  break; // shouldn't need this?

  case 'r':
  case 'R': // report our data
  ReportData();
  break;
 }

 did_something = true;
 handle_host = false; // we did it
}
////////////////////////////////////////////

void setup() {

  init_ram();
  Serial.begin(115200);
  pinMode(LED_BUILTIN, OUTPUT);
  adV.setGain(GAIN_FOUR);       // 4x gain   +/- 1.024V  1 bit =  0.03125mV
  adV.begin();
  adV.startADC_Differential_0_1(); // start continuous mode on ch 0
  
  adA.setGain(GAIN_EIGHT);       // 8x gain   +/- 1.024V  1 bit =  0.015625mV
  adA.begin();
  adA.startADC_Differential_0_1(); // start continuous mode on ch 0
  
  // by default, we'll generate the high voltage from the 3.3v line internally! (neat!)
  display.begin(SSD1306_SWITCHCAPVCC, D_ADDR);  // initialize with the I2C addr 0x3D (for the 128x64)
  if (! sht31.begin(0x44))
  {
   Serial.println("Sht31 no init");
   while (1) delay (1); // @@@ add "only hang in debug" mode!!!
  }
  // Show image buffer on the display hardware.
  // Since the buffer is intialized with an Adafruit splashscreen
  // internally, this will display the splashscreen.
  display.display();
  delay(2000);
  // Clear the buffer.
  display.clearDisplay();
  display.display(); // show the nothing

  WiFi.config(ip, gateway, subnet);
  WiFi.begin(WAP, WPASS);
  while (WiFi.status() != WL_CONNECTED) { // wait for dhcp
   delay(500);
   Serial.print(F("."));
  }
   WiFi.config(ip, gateway, subnet);

  tport.begin(DNSPORT);
  dport.begin(DATAPORT);
  build_host_info();
}
////////////////////////////////////////////

void loop() {
  did_something = false; // we haven't yet
  minm = millis() - milliz;
  if (minm >= 60000)
  {
   tellem(); 
   milliz = millis();
   minm = 0; 
   yield();
   if (debug) ReportData(); // else wait to be asked
   did_something = true;  // because we did something
  }
 
   mins = millis() - millizs; // seconds scheduler
   if (mins >= 1000)
   { // seconds hit but not top of minute (busy then with other shit)
    millizs = millis(); // set up for next second
    do_update = true; // schedule this
    do_ditch = true;  // this too
    do_update_display = true; // for lcd
  

    digitalWrite(LED_BUILTIN,!digitalRead(LED_BUILTIN)); // blink
    
   }  // once per second

    // do scheduled things - but only one per pass
    // priority adjusted by list order
    if (!did_something && do_update) update_readings(); // read sensors
    if (!did_something && handle_host) HandleHost(); 
    if (!did_something && do_update_display) update_display();
    if (!did_something && do_ditch) ditch_incoming(); // in case it matters?

    if (!did_something) // special, as we check this every loop
    { // in this case, just checking might take some time
     CmdSize = dport.parsePacket(); 
     if (CmdSize) handle_host = true; // grab this next roundy round
    }   
   

} // end of loop
